- NAME
- SYNOPSIS
- DESCRIPTION
- IMPORT
- EXCEPTIONS
- FIELDS
- EXCEPTION METHODS
- EXCEPTION CLASS CHECKING

# NAME

HTML::Mason::Exceptions - Exception objects thrown by Mason

# SYNOPSIS

      use HTML::Mason::Exceptions ( abbr => [ qw(system_error) ] );

      open FH, 'foo' or system_error "cannot open foo: $!";

# DESCRIPTION

This module creates the hierarchy of exception objects used by Mason, and provides some extra methods for them beyond those provided by `Exception::Class`

# IMPORT

When this module is imported, it is possible to specify a list of abbreviated function names that you want to use to throw exceptions. In the SYNOPSIS example, we use the `system_error` function to throw a `HTML::Mason::Exception::System` exception.

These abbreviated functions do not allow you to set additional fields in the exception, only the message.

# EXCEPTIONS

HTML::Mason::Exception

  This is the parent class for all exceptions thrown by Mason. Mason sometimes throws exceptions in this class when we could not find a better category for the message.

  Abbreviated as `error`

HTML::Mason::Exception::Abort

  The `$m->abort` method was called.

  Exceptions in this class contain the field `aborted_value`.

HTML::Mason::Exception::Decline

  The `$m->decline` method was called.

  Exceptions in this class contain the field `declined_value`.

HTML::Mason::Exception::Compilation

  An exception occurred when attempting to `eval` an existing object file.

  Exceptions in this class have the field `filename`, which indicates what file contained the code that caused the error.

  Abbreviated as `compilation_error`.

HTML::Mason::Exception::Compiler

  The compiler threw an exception because it received incorrect input. For example, this would be thrown if the lexer told the compiler to initialize compilation while it was in the middle of compiling another component.

  Abbreviated as `compiler_error`.

HTML::Mason::Exception::Compilation::IncompatibleCompiler

  A component was compiled by a compiler or lexer with incompatible options. This is used to tell Mason to recompile a component.

  Abbreviated as `wrong_compiler_error`.

HTML::Mason::Exception::Params

  Invalid parameters were passed to a method or function.

  Abbreviated as `param_error`.

HTML::Mason::Exception::Syntax

  This exception indicates that a component contained invalid syntax.

  Exceptions in this class have the fields `source_line`, which is the actual source where the error was found, `comp_name`, and `line_number`.

  Abbreviated as `syntax_error`.

HTML::Mason::Exception::System

  A system call of some sort, such as a file open, failed.

  Abbreviated as `system_error`.

HTML::Mason::Exception::TopLevelNotFound

  The requested top level component could not be found.

  Abbreviated as `top_level_not_found_error`.

HTML::Mason::VirtualMethod

  Some piece of code attempted to call a virtual method which was not overridden.

  Abbreviated as `virtual_error`

# FIELDS

Some of the exceptions mentioned above have additional fields, which are available via accessors. For example, to get the line number of an `HTML::Mason::Exception::Syntax` exception, you call the `line_number` method on the exception object.

# EXCEPTION METHODS

All of the Mason exceptions implement the following methods:

as_brief

  This simply returns the exception message, without any trace information.

as_line

  This returns the exception message and its trace information, all on a single line with tabs between the message and each frame of the stack trace.

as_text

  This returns the exception message and stack information, with each frame on a separate line.

as_html

  This returns the exception message and stack as an HTML page.

Each of these methods corresponds to a valid error_format parameter for the Request object such as `text` or `html`.

You can create your own method in the `HTML::Mason::Exception` namespace, such as `as_you_wish`, in which case you could set this parameter to ``you_wish''. This method will receive a single argument, the exception object, and is expected to return some sort of string containing the formatted error message.

# EXCEPTION CLASS CHECKING

This module also exports the `isa_mason_exception` function. This function takes the exception object and an optional string parameter indicating what subclass to check for.

So it can be called either as:

      if ( isa_mason_exception($@) ) { ... }

or

      if ( isa_mason_exception($@, 'Syntax') ) { ... }

Note that when specifying a subclass you should not include the leading ``HTML::Mason::Exception::'' portion of the class name.